<?php /* mp3toFlash.php4
# MP3Jukebox from Daniel Lonn: http://www.webknecht.net
# MP3ID3-Script from Ansgar Becker: http://www.php-center.de/artikel/id3.php3 
# 
# Launch MP3Jukebox with "mp3" as Mp3-Directory
# jukebox.php?dir=mp3/ <= with current MP3-Data
# mp3jukebox.php?dir=mp3  <= with Reloading MP3-Data
# 
# Specifikations for Winamp-Extensions:  http://www.id3.org */


$arr_id3 = array(
array("Artist",33,30),
array("Song",3,30),
array("Album",63,30),
array("Year",93,4),
array("Comment",97,30)
);
$dir=$HTTP_GET_VARS['dir'];
if($dir){
$STR_XML="<?xml version=\"1.0\" encoding=\"UTF-8\"?><DATA>";
$FILE_XML = $dir."/mp3.xml";
$arr_artistTmp=array();
$arr_data=array();
if($path = @dir($dir."/")){
while($file = $path->read()){
 if(getExt($file)=="mp3"){
   $mp3found=1;
   $file = $dir."/".$file;
   $arr_data = getId3Tags($file,$arr_id3,$STR_XML,$arr_data);
}
}
$path->close();
if($mp3found==1){
sort($arr_data);
$STR_XML = getXmlData($arr_data,$STR_XML,$arr_id3);
$FILE = fopen($FILE_XML,"w+");
fputs($FILE,$STR_XML);
fclose($FILE);
header("Location: jukebox.php?dir=$dir");
}else{
echo "<h1>Keine Mp3s gefunden im Ordner $dir/!</h1>";
echo "<h1>No Mp3s found in directory $dir/!</h1>";
}
}else{
echo "<h1>Ordner $dir/ wurde nicht gefunden!</h1>";
echo "<h1>Directory $dir/ not found!</h1>";
}
}else{
echo "<h1>Aufruf der mp3Jukebox: 'mp3jukebox.php4?dir=ORDNER'</h1>";
echo "<h1>Call of mp3Jukebox: 'mp3jukebox.php4?dir=DIRECTORY'</h1>";
}

function getExt($file) {
$arr_tmp = explode(".", $file);
return $arr_tmp[1];
}

function getId3Tags($filename,$arr_id3,$STR_XML,$arr_data){
if (filesize($filename) > 128){
$fp = fopen($filename, "r");
fseek($fp, filesize($filename) - 128);
$id3 = fread($fp, 128);
if (strtoupper(substr($id3, 0, 3)) == "TAG"){
$arr_Tmp=array();
for($i=0;$i<count($arr_id3);$i++){
$val = htmlspecialchars(trim(substr($id3, $arr_id3[$i][1], $arr_id3[$i][2])));
array_push($arr_Tmp,$val);
}
array_push($arr_Tmp,$filename);
array_push($arr_data,$arr_Tmp);
fclose($fp);
}
}
return $arr_data;
}

function getXmlData($arr_data,$STR_XML,$arr_id3){
for($j=0;$j<count($arr_data);$j++){
if($j==0 || ($j>0 && $arr_data[$j][0] != $arr_data[($j-1)][0])){
$STR_XML.="<ARTIST ".$arr_id3[0][0]."='".$arr_data[$j][0]."'>";
}
$STR_XML.="<MP3 ";
for($i=1;$i<(count($arr_id3)-1);$i++){
$STR_XML.=$arr_id3[$i][0]."=\"".$arr_data[$j][$i]."\" ";
}
$STR_XML.=" Filepath=\"".$arr_data[$j][count($arr_id3)]."\" ";
$STR_XML.=" />";
if(($j>0 && $arr_data[$j][0] != $arr_data[($j+1)][0])){
$STR_XML.="</ARTIST>";
}
}
$STR_XML.="</DATA>";
return $STR_XML;
}
?>
